/*
* Welcome to your app's main JavaScript file!
*
* We recommend including the built version of this JavaScript file
* (and its CSS file) in your base layout (base.html.twig).
*/

// any CSS you import will output into a single css file (app.css in this case)

// start the Stimulus application
//import './bootstrap';

const { default: consolaGlobalInstance } = require('consola');
var Calendar = require('tui-calendar'); /* CommonJS */
var UserLevel = 0;
document.getElementById("userLvl").innerHTML = UserLevel;
console.log(UserLevel);

$(function () {
  var calendar = new Calendar('#calendar', {
    defaultView: 'week',
    taskView: false,
    useCreationPopup: true,
    useDetailPopup: true
  });

  function getStartAndEndDates() {
    let dateStart = String(calendar.getDateRangeStart().toDate()).slice(4, 15);
    document.getElementById("dateStart").innerHTML = dateStart;
    let dateEnd = String(calendar.getDateRangeEnd().toDate()).slice(4, 15);
    document.getElementById("dateEnd").innerHTML = dateEnd;
  }

  getStartAndEndDates();
  var scheduleIds = []
  var currentSchedule = 1

  function getAllSchedules() {
    var schedules = []
    scheduleIds.forEach(function (id) {
      var schedule = calendar.getSchedule(String(id), '1');
      schedules[schedules.length] = schedule
    })

    return schedules
  }

  function sendCalendarData() {
    var schedules = getAllSchedules();


    $.ajax({
      type: "POST",
      url: "/calendar/send",
      data: JSON.stringify(schedules),
      dataType: "json",
      contentType: 'application/json'
    });
  }

  console.log($("#btn-yes-feedback"))
  $("#btn-yes-feedback").on('click', function (event) {
    $.ajax({
      type: "POST",
      url: "/calendar/send_click",
      success: function (data) {
        console.log(data);
        UserLevel = data.score;
        document.getElementById("userLvl").innerHTML = parseInt(UserLevel, 10);
      }
    })
  })

  calendar.on('beforeCreateSchedule', function (event) {
    var scheduleData = event
    // var calendarId = '1';
    var schedule = {
      id: String(currentSchedule),
      calendarId: '1',
      title: scheduleData.title,
      isAllDay: scheduleData.isAllDay,
      start: scheduleData.start,
      end: scheduleData.end,
      category: scheduleData.isAllDay ? 'allday' : 'time',
      dueDateClass: '',
      color: calendar.color,
      bgColor: calendar.bgColor,
      dragBgColor: calendar.bgColor,
      borderColor: calendar.borderColor,
      location: scheduleData.location,
      isPrivate: scheduleData.isPrivate,
      state: scheduleData.state
    };

    scheduleIds[scheduleIds.length] = currentSchedule;
    currentSchedule++;

    calendar.createSchedules([schedule]);

    sendCalendarData();
  });

  calendar.on('beforeDeleteSchedule', function (event) {
    calendar.deleteSchedule(event.schedule.id, event.schedule.calendarId);
    sendCalendarData();
  });

  prevBtn.addEventListener("click", e => {
    calendar.prev();
    getStartAndEndDates();
  });
  nextBtn.addEventListener("click", e => {
    calendar.next();
    sendCalendarData();
    getStartAndEndDates();
  });

  calendar.on('beforeUpdateSchedule', function (event) {
    var schedule = event.schedule;
    var changes = event.changes;

    changes.calendarId = "1"

    calendar.updateSchedule(schedule.id, schedule.calendarId, changes);
    sendCalendarData();
  });


  $.ajax({
    type: "POST",
    url: "/calendar/receive",
    success: function (data) {
      var cleanedData = []
      if (Array.isArray(data)) {
        data.forEach(function (schedule) {
          if (schedule) {
            schedule.start = schedule.start._date
            schedule.end = schedule.end._date
            scheduleIds[scheduleIds.length] = parseInt(schedule.id)
            currentSchedule++
            cleanedData[cleanedData.length] = schedule
          }
        })

        calendar.createSchedules(cleanedData)
      }

    },
  });

  function createSchedule(start, end, title) {
    var schedule = {
      id: String(currentSchedule),
      calendarId: '1',
      title: title,
      start: start,
      end: end,
      category: 'time'
    };

    scheduleIds[scheduleIds.length] = currentSchedule;
    currentSchedule++;

    calendar.createSchedules([schedule]);
  }

  $(planForm).on('submit', function (e) {
    e.preventDefault();
    // taskPlan, hoursPlan, deadlinePlan
    var deadline = new Date(deadlinePlan.value + "T00:00:00-05:00")
    console.log(deadline)
    var today = new Date()
    var day = new Date(new Date().setDate(today.getDate() + 1))
    var schedules = getAllSchedules();

    console.log(schedules)

    var days = []
    var availableHoursTotal = 0
    while (day.getDate() <= deadline.getDate()) {
      day.availableHours = 10; // de 8h à 18h
      day.schedules = []
      var minTime = new Date(day)
      minTime.setHours(8)
      minTime.setMinutes(0)
      minTime.setSeconds(0)
      var maxTime = new Date(day)
      maxTime.setHours(18)
      maxTime.setMinutes(0)
      maxTime.setSeconds(0)

      schedules.forEach(function (schedule) {
        if (schedule) {
          startTime = schedule.start._date
          endTime = schedule.end._date
          if (endTime > minTime && startTime < maxTime) {
            if (startTime < minTime) {
              startTime = minTime
            }
            if (endTime > maxTime) {
              endTime = maxTime
            }
            minutes = endTime.getMinutes() - startTime.getMinutes()
            day.availableHours -= (minutes / 60)
            day.schedules[day.schedules.length] = schedule
          }
        }
      })
      availableHoursTotal += day.availableHours

      days[days.length] = day

      day = new Date(new Date().setDate(day.getDate() + 1))
    }

    var hoursToWork = hoursPlan.value
    var task = taskPlan.value

    if (hoursToWork > availableHoursTotal) {
      alert("There are more hours of work to do than what is available !")
      return
    }

    days.forEach(function (day) {
      console.log("day", day)
      console.log("hours total", availableHoursTotal)
      console.log("day total", day.availableHours)
      hoursToPlace = (day.availableHours / availableHoursTotal) * hoursToWork
      beginTime = new Date()
      beginTime.setDate(day.getDate())
      beginTime.setHours(8)
      beginTime.setMinutes(0)
      beginTime.setSeconds(0)
      endTime = new Date(beginTime)
      endTime.setHours(9)
      i = 0
      while (hoursToPlace > 0 && i < 50) {
        console.log("hours", hoursToPlace)
        clear = true
        getAllSchedules().forEach(function (schedule) {
          console.log("schedule", schedule)
          // console.log(schedule.start._date)
          // console.log(beginTime, endTime, schedule.start._date, schedule.end._date)
          if (schedule) {
            if (beginTime <= schedule.start._date && schedule.start._date <= endTime) {
              clear = false
              console.log("not clear 1")
            }
            if (beginTime <= schedule.end._date && schedule.end._date <= endTime) {
              clear = false
              console.log("not clear 2")
            }
            if (schedule.start._date < beginTime && schedule.end._date > endTime)
            {
              clear = false
              console.log("not clear 3")
            }
          }
        })
        if (clear) {
          createSchedule(beginTime, endTime, task)
          hoursToPlace--;
        }
        beginTime.setHours(beginTime.getHours() + 1)
        endTime.setHours(endTime.getHours() + 1)
        console.log("check new begin and end")
        console.log(beginTime)
        console.log(endTime)
        i++;
      }
      if (i > 50) alert("FATAL ERROR!!!!")
    })

    sendCalendarData();
  })

  $("#clearPlanButton").on('click', function (e) {
    var schedules = getAllSchedules()
    schedules.forEach(function (schedule) {
      if (schedule && schedule.title == taskPlan.value) {
        calendar.deleteSchedule(schedule.id, schedule.calendarId);
      }
    })
    sendCalendarData();
  })
});
